################################################################################
#------------------------------------------------------------------------------
# Skrypt realizujacy graficzna reprezentacje dla projektu Skrzyzowanie
#
# Autor: Remigiusz Wisniewski
# Uniwersytet Zielonogorski 2003
#------------------------------------------------------------------------------
################################################################################
# USTAWIENIA POCZATKOWE
wm withdraw . 		  
package require ::aldec::scripter 1.0 	  

set dsn [::aldec::scripter::GetVariable "dsn"] 

# KOMPILACJA PLIKOW
alog {$dsn\src\Skrzyzowanie.v}

# USTAWIENIE TOP-LEVEL (lights) - inicjalizacja symulacji
if {![asim lights]} {
	PrintString "TCL: Nie mozna zainicjalizowac symulacji!" 1
	exit
} else {


# PRZYGOTOWANIE DO SYMULACJI
	::aldec::scripter::ExecuteScript "open" {-wave $dsn\src\skrzyzowanie.awf}
	force Clk 0 0, 1 50 ns -r 100 ns
	
################################################################################

# PRZYPISANIE ZMIENNYM RYSUNKOW
	image create photo Reset \
		-file [file join $dsn src images reset.gif]
	image create photo Red \
		-file [file join $dsn src images red.gif]
	image create photo RedYellow \
		-file [file join $dsn src images redyellow.gif]
	image create photo Yellow \
		-file [file join $dsn src images yellow.gif]
	image create photo Green \
		-file [file join $dsn src images green.gif]

# Zmienna kontrolujaca wyjscia ukladu oraz funkcja ja ustawiajaca:
	set Lights 0;				   
	proc SetLights {} {
		global Lights
		set Lights 0;				   

		if {[examine R] == 1} {
			set Lights [expr $Lights + 1]
		}
		if {[examine Y] == 1} {
			set Lights [expr $Lights + 2]
		}				  
		if {[examine G] == 1} {
			set Lights [expr $Lights + 4]
		}
			
	}

################################################################################
# USTAWIENIA GUI
	proc ExitProc {} {
		noforce Clk	 
		endsim
	}				  
	
	wm iconify .
	wm deiconify .		  
	
	set RGB 0			
	set simMode true
	
	# Ustawienia okna glownego
	wm title . "SKRZYZOWANIE"
	wm geometry . 480x484+275+107	
							  
	# Ustawienia rysunku i przyciskow						  		
	label .picture1 \
		-borderwidth 0 \
		-image Reset 

	label .label1 \
		-background #008000 \
		-foreground #ffffff 
		
	button .button1 \
        -text START \
		-command {		  
			if {[examine Reset]!=0} {	
				force Reset 1
				force Mode 0
				run 50 ns
				.button2 configure -state normal
				force Reset 0
				run 50 ns
			}
			if {$simMode} {
				.button1 configure -text "Wlacz swiatla";
				set simMode false						 
				.label1 configure -text "Swiatla sa wylaczone"
				force Mode 0
			} else { 
				.button1 configure -text "Wylacz swiatla";
				set simMode true
				.label1 configure -text "Swiatla sa wlaczone"
				force Mode 1
			}					  
		}
    	
	button .button2 \
        -font "-family lucida -size 18 -weight normal -slant roman -underline 0 -overstrike 0" \
		-text DALEJ \
		-state disabled \
		-command {		
			run 100 ns;		 
			SetLights;
			switch $Lights {
				1 {.picture1 configure -image Red}
				2 {.picture1 configure -image Yellow}
				3 {.picture1 configure -image RedYellow}
				4 {.picture1 configure -image Green}
				default {.picture1 configure -image Reset}
			}
		}

	button .button3 \
        -text Koniec \
		-command {
			ExitProc; 
			destroy;
			set end_tcl true; 
			exit
		}


	#Polozenie rysunku i przyciskow
	place .picture1 \
        -x 0 -y 0 -width 481 -height 487 -anchor nw -bordermode ignore 
	place .label1 \
        -x 350 -y 10 -width 135 -height 30 -anchor nw -bordermode ignore 
	place .button1 \
        -x 350 -y 45 -width 115 -height 30 -anchor nw -bordermode ignore 
    place .button2 \
        -x 350 -y 77 -width 115 -height 60 -anchor nw -bordermode ignore 
    place .button3 \
        -x 350 -y 139 -width 115 -height 30 -anchor nw -bordermode ignore 

#	SetLights;
	wm protocol . WM_DELETE_WINDOW "ExitProc;set end_tcl true; exit"
}